Config (Grails 4.0.6)
Date: 2020-12-19

Package: grails.config

## [Groovy] Interface Config

- grails.config.ConfigMap

- All Superinterfaces:
    ConfigMap

  Interface to application configuration

  Authors:
    Graeme Rocher
  Since:
    3.0

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `java.util.Map<java.lang.String, java.lang.Object>` | `flatten()` @return The flat version of the config
    `<T>` | `T` | `getProperty(java.lang.String key, java.lang.Class<T> targetType, T defaultValue, java.util.List<T> allowedValues)` Return the property value associated with the given key, or `defaultValue` if the key cannot be resolved.
    `` | `Config` | `merge(java.util.Map<java.lang.String, java.lang.Object> toMerge)` Merge another config and return this config
    `` | `java.util.Properties` | `toProperties()` Converts the config to properties

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `interface ConfigMap` | `getAt, getProperty, getProperty, getRequiredProperty, navigate, setAt`
    `interface org.springframework.core.env.PropertyResolver` | `org.springframework.core.env.PropertyResolver#resolvePlaceholders(java.lang.String), org.springframework.core.env.PropertyResolver#resolveRequiredPlaceholders(java.lang.String), org.springframework.core.env.PropertyResolver#containsProperty(java.lang.String), org.springframework.core.env.PropertyResolver#getRequiredProperty(java.lang.String), org.springframework.core.env.PropertyResolver#getRequiredProperty(java.lang.String, java.lang.Class), org.springframework.core.env.PropertyResolver#getProperty(java.lang.String, java.lang.Class, java.lang.Object), org.springframework.core.env.PropertyResolver#getProperty(java.lang.String), org.springframework.core.env.PropertyResolver#getProperty(java.lang.String, java.lang.Class), org.springframework.core.env.PropertyResolver#getProperty(java.lang.String, java.lang.String)`

- - ### Method Detail

    - #### @java.lang.Deprecated java.util.Map<java.lang.String, java.lang.Object> flatten()

      Returns:
        The flat version of the config

    - #### <T> T getProperty(java.lang.String key, java.lang.Class<T> targetType, T defaultValue, java.util.List<T> allowedValues)

      Return the property value associated with the given key, or `defaultValue` if the key cannot be resolved.

      Parameters:
        `key` - the property name to resolve
        `targetType` - the expected type of the property value
        `defaultValue` - the default value to return if no value is found
        `the` - allowable values
      See Also:
        getRequiredProperty(String, Class)

    - #### Config merge(java.util.Map<java.lang.String, java.lang.Object> toMerge)

      Merge another config and return this config

      Parameters:
        `toMerge` - The map to merge
      Returns:
        This config

    - #### java.util.Properties toProperties()

      Converts the config to properties

      Returns:
        The properties